#include <SDL.h>
#include <SDL_image.h>

#include "sdl_image_gp2x.h"

SDL_Surface *LoadImage(const char *file, Uint32 c)
{
	SDL_Surface *surface;

	// Load image into surface
	printf("Loading \"%s\"...", file);
	surface = IMG_Load(file);
	if(!surface)
	{
		printf("\t\t\t\tERROR\n");
		SDL_Quit();
	}
	else
		printf("\t\t\t\tOK\n");

	// Set color key
	SDL_SetColorKey(surface, SDL_SRCCOLORKEY | SDL_RLEACCEL, c);

	// Convert surface to display format
	surface = SDL_DisplayFormat(surface);

	// Return surface
	return surface;
}

char *GetImageFormat(const char *file)
{
	SDL_RWops *rwop;
	char *c;

	// Load image into surface
	rwop = SDL_RWFromFile(file, "rb");

	// Get image format
	if(IMG_isBMP(rwop)) c = "bmp"; else
	if(IMG_isPNM(rwop)) c = "pnm"; else
	if(IMG_isXPM(rwop)) c = "xpm"; else
	if(IMG_isXCF(rwop)) c = "xcf"; else
	if(IMG_isPCX(rwop)) c = "pcx"; else
	if(IMG_isGIF(rwop)) c = "gif"; else
	if(IMG_isJPG(rwop)) c = "jpg"; else
	if(IMG_isTIF(rwop)) c = "tif"; else
	if(IMG_isPNG(rwop)) c = "png"; else
	if(IMG_isLBM(rwop)) c = "lbm"; else
	c = "Unknown";

	// Free RWop
	SDL_FreeRW(rwop);

	// Return image format
	return c;
}
